// editor.cpp
// strip resource data from DTA files (save10.dta)
// by shaktazuki

// macro to spit out resource type as int; the last is none. 0x81 through 0x90 = Raw, 0x41 - 0x50 = gold, 0x21 - 0x30 = fuel.
#define type(x) ((x > 0x80 && x < 0x91)?LTGRAY:(x > 0x40 && x < 0x51)?LTYELLOW:(x > 0x20 && x < 0x31)?LTGREEN:BLUE)
// macro to spit out resource type as char.  Should be equivalent to the one above.
//#define typetxt(x) (((x ^ 0x80) && (x & 0x80))?'R':((x ^ 0x40) && (x & 0x40))?'G':((x ^ 0x20) && (x & 0x20))?'F':'=')

#define BMP_DIM 112 // should be a multiple of 112, we will have an array with the x dimension half this value

#include <fstream>
#include <iostream>
#include "C:\\Documents and Settings\\CCity\\My Documents\\Visual Studio 2008\\Projects\\bmp16\\bmp16\\bmp16.h"
using namespace std;

int main(int argc, char argv[])
{
	char in;
	ifstream infile("c:\\dosgames\\max\\save10.dta");
	//ofstream outfile("C:\\Documents and Settings\\CCity\\Desktop\\max resource level examples\\resource.txt");
	
	char filename[] = "C:\\Documents and Settings\\CCity\\Desktop\\max resource level examples\\resource.bmp";
	unsigned char bmpdata[BMP_DIM / 2][BMP_DIM];
	
	// initialize bmpdata to 0
	for(int i = 0; i < BMP_DIM / 2; i++)
	{
		for(int j = 0; j < BMP_DIM; j++)
		{
			bmpdata[i][j]=0;
		}
	}
	
	if(!infile)
	{
		cout << "Could not open c:\\dosgames\\max\\save10.dta." << endl;
		cin.get();
		return -1;
	}
	/*if(!outfile)
	{
		cout << "Could not open C:\\Documents and Settings\\CCity\\Desktop\\max resource level examples\\resource.bmp"<< endl;
		cin.get();
		return -1;
	}*/

	infile.seekg(12768);// offset in decimal of resource map in the DTA file

	for(int i = 0; i < 112 && infile.tellg() <= 37854; i++)
	{
		for(int j = 0; j < 112 && infile.tellg() <= 37854; j++)
		{
			infile.get(in);
			infile.ignore(); // ignore the next character (this was probably originally stored as an int)
			//outfile << typetxt((unsigned char) in);
			if(i % 2)// if i is odd
			{
				bmpdata[i / 2][j] |= type((unsigned char)in); // set the low bits
			}
			else
			{
				bmpdata[i / 2][j] |= type((unsigned char)in) << 4; // set the high bits
			}
		}
		//outfile << endl;
	}
	infile.close();
	//outfile.close();
	writebmp16(filename, BMP_DIM, BMP_DIM, (unsigned char *)&bmpdata);
	return 0;
}
	
